// This is the part of MPFRCPP, the C++ interface for MPFR library.

// Copyright (C) 2006 Alexey Beshenov <bav.272304@gmail.com>

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
// MA 02110-1301 USA.

#ifndef __INTEGER_RELATED_CPP
#define __INTEGER_RELATED_CPP

//------------------------------------------------------------
// MPFRCPP INTEGER RELATED FUNCTIONS
//------------------------------------------------------------

bool is_integer (const MPFR& x)
    {
    if ( mpfr_integer_p(x.mpc_x) == 0 ) { return false; }
    else { return true; }
    }


MPFR ceil (const MPFR &x)
    {
    MPFR y(x.prec(), x.round_mode());
    mpfr_rint_ceil (y.mpc_x, x.mpc_x, x.mpc_round_mode);
    return y;
    }


MPFR floor (const MPFR &x)
    {
    MPFR y(x.prec(), x.round_mode());
    mpfr_rint_floor (y.mpc_x, x.mpc_x, x.mpc_round_mode);
    return y;
    }


MPFR round (const MPFR &x)
    {
    MPFR y(x.prec(), x.round_mode());
    mpfr_rint_round (y.mpc_x, x.mpc_x, x.mpc_round_mode);
    return y;
    }


MPFR trunc (const MPFR &x)
    {
    MPFR y(x.prec(), x.round_mode());
    mpfr_rint_trunc (y.mpc_x, x.mpc_x, x.mpc_round_mode);
    return y;
    }


MPFR frac (const MPFR &x)
    {
    MPFR y(x.prec(), x.round_mode());
    mpfr_frac (y.mpc_x, x.mpc_x, x.mpc_round_mode);
    return y;
    }

#endif                                            // __INTEGER_RELATED_CPP
